'''
Control this parallel port relay board:
http://www.electronickits.com/kit/complete/elec/ck1601.htm

Requires installing GiveIO. Note that that might be a security risk. See:
http://linuxgazette.net/112/radcliffe.html

Might also require simpleio.dll to be placed in the windows/system32 folder.

And of course requires the pyparallel module.

Feel free to email wrybread@gmail.com if you can't get it working.

Usage:
k74(1, 0) turns relay 1 off.
k74(2, 1) turns relay 2 on.
k74(0, 1) turns all on
k74(0, 0) turns all off
'''

import time

def k74(relay, state):

    global relays_dict

    # Check if the relay dictionary has been defined yet
    try: relays_dict
    except NameError:
        # Define it
        relays_dict = {}
        for i in range(1, 8): relays_dict[i] = 0

    # Now set the new relay value in our dictionary
    relays_dict[relay] = state

    # Build the output string (there's probably a better way to do this)
    output = ""
    for key in relays_dict.iterkeys():
        output += str( relays_dict[key] )

    # Reverse it
    output = output[::-1]

    # Handle all on and all off, as in k74(0, 1) for all on
    if relay == 0 and state == 0: output = "00000000"
    if relay == 0 and state == 1: output = "11111111"

    # Convert it to binary:
    x = int(output, 2)

    # Write to the parallel port:
    import parallel
    port = parallel.Parallel()
    port.setData(x)


k74(4,1)

time.sleep(.5)

k74(4,0)
